/*********************************************
 *
 * Tasten abfragen
 *
 * Aktiv Low Taster an PC5
 * LED an Port PD6
 * Takt extern, 12MHz
 *
 *********************************************/
#include <avr/io.h>
#ifndef F_CPU
#define F_CPU 12000000UL     // Quarz 12MHz
#endif
#include <util/delay.h>


inline uint8_t key_pressed(volatile uint8_t *port, uint8_t pin)
{
    /* active low button means, bits is clear */
    if ( ! (*port & (1 << pin)) )
    {
        _delay_ms(20);
        _delay_ms(20);
        if ( ! (*port & (1 << pin)) ) return 1;
    }
    return 0;
}


int main( void )
{

    DDRC &= ~( 1 << PC5 );      // PC5 an PORTC als Eingang setzen
    PORTC |= ( 1 << PC5 );      // Pullup-Widerstand aktivieren
    DDRD = ( 1 << PD6 );        // PD6 an PORTD als Ausgang setzen
 
    while( 1 ) {                // Endlosschleife

        if (key_pressed(&PINC, PC5))
            PORTD = PIND ^ (1 << PD6);    // toggle PD6 an PortD
    }
 
    return 0;
}
