#include "main.h"
//#include <math.h>

void start_meas( void ){
  if( W1_IN & 1<< W1_PIN ){
    w1_command( CONVERT_T, NULL );
    W1_OUT |= 1<< W1_PIN;
    W1_DDR |= 1<< W1_PIN;			// parasite power on

  }else{
    //uputsnl( "Short Circuit !" );
    lcd_puts( "Short Circuit !" );
  }
}


void read_meas( void )
{
  uchar id[8], diff;
  char s[30];
  uchar i;
  uint16_t temp, cpc, cr, crc, subzero;

  lcd_clrscr();
  for( diff = SEARCH_FIRST; diff != LAST_DEVICE; ){
    diff = w1_rom_search( diff, id );

    if( diff == PRESENCE_ERR ){
      //uputsnl( "No Sensor found" );
      lcd_puts( "No Sensor found\n" );
      break;
    }
    if( diff == DATA_ERR ){
      //uputsnl( "Bus Error" );
      lcd_puts( "Bus Error\n" );
      break;
    }
    if( id[0] == 0x28 || id[0] == 0x10 ){	// temperature sensor
     // lcd_puts( "ID: " );
     for( i = 0; i < 8; i++ ){
	sprintf( s, "%02X", id[i] );
	//uputs( s );
	lcd_puts( s );
      }
      w1_byte_wr( READ );			// read command
      temp = w1_byte_rd();			// low byte
      temp |= (w1_byte_rd())<<8;			// high byte
      if ( temp & 0x8000 ) {				// negativ temp.
        temp ^= 0xffff;				// invert temp
        temp++;
        subzero = 1;				// mark negativ temp
      } else {
        subzero = 0;
      }
      w1_byte_rd();                     // User Byte 1
      w1_byte_rd();                     // User Byte 2
      w1_byte_rd();                     // Reserve
      w1_byte_rd();                     // Reserve
      cr = (uint16_t)w1_byte_rd();      // Count Remain
      cpc = (uint16_t)w1_byte_rd();     // Count Per C
      crc = (uint16_t)w1_byte_rd();     // CRC
//      temp =temp>>1; 	// trenne 0.5C bit ab
//      temp=temp*10-25+((cpc-cr)*10)/cpc;
//      sprintf( s, "Temp: %c%4d.%01d C", (subzero)?'-':'+', temp/10, temp%10); // display Temperatur
      sprintf( s, "Temp: %c%i.%i C", (subzero)?'-':'+', temp>>1, (temp & 0x0001)*5); // display Temperatur
      lcd_gotoxy(0,1);
      lcd_puts(s);
    }
  }
  //uputsnl( "" );
}
