#include <stdio.h>
#include <unistd.h>
#include <usb.h>
#include "hostlib.h"

/* globale variablen */
#define uint64 unsigned long int

/* functions */
void echotest(avr_device_t _device, int val)
{
  char buffer[256];
  int len, i = 0;

  // send val, read echo
  printf ("Send: %u ", val);
  len = avr_get_response(_device, AVR_ECHOTEST, val, buffer, sizeof(buffer));
  // display real buffer
  printf ("read: %u\n", buffer[2]);
  //printf("%i::", len);
  //for (i=1; i<=len; i++) printf("%u ", buffer[i]);
  //printf("\n");
}


uint64 getkey_rc5(avr_device_t _device)
{
    uint64 code;
    char buffer[50];
    int bufferCounter = 3;
    int len = 0;

    int rc5Code[20];
    int bitCounter = 0;
    int lastLevelHigh = 1;
    int newBit = 0;

    len = avr_get_response(_device, AVR_INFRA_GET_CODE, 0, buffer, 50);
    if (len > 1){
        avr_send_command(_device, AVR_INFRA_BUFFER_EMPTY, 0);

        for(;bufferCounter <= len;){
                if (newBit){
                        if ((unsigned char)buffer[bufferCounter] < 15) lastLevelHigh = lastLevelHigh ? 0 : 1 ;
                        bufferCounter++;
                        newBit = 0;
                }else{
                        rc5Code[bitCounter] = lastLevelHigh ? 1 : 0;
                        bitCounter++;
                        if ((unsigned char)buffer[bufferCounter] < 15) bufferCounter++;
                        newBit = 1;
                        lastLevelHigh = lastLevelHigh ? 0 : 1;
                }
        }

        // Ceck if it is RC5
        if ( !(rc5Code[0] && rc5Code[1] && (bitCounter == 14) ) ) {
          printf ("no rc5 code\n");
          return 0;
        } 

        // Set Code to 0
        code = 0;

        // Key Code
        if (rc5Code[13] == 1) code = code | 0x0001;
        if (rc5Code[12] == 1) code = code | 0x0002;
        if (rc5Code[11] == 1) code = code | 0x0004;
        if (rc5Code[10] == 1) code = code | 0x0008;
        if (rc5Code[9] == 1) code = code | 0x0010;
        if (rc5Code[8] == 1) code = code | 0x0020;

        // Addres Code
        if (rc5Code[7] == 1) code = code | 0x0100;
        if (rc5Code[6] == 1) code = code | 0x0200;
        if (rc5Code[5] == 1) code = code | 0x0400;
        if (rc5Code[4] == 1) code = code | 0x0800;
        if (rc5Code[3] == 1) code = code | 0x1000;

        // Toggle Bit
        if (rc5Code[2] == 1) code = code | 0x8000;

        //DEBUG((" (len: %d, bytes: %d, nummber: %d, seperator: %d)\n",len, (unsigned int)buffer[0],(unsigned int)buffer[1],(unsigned int)buffer[2] ));

        return code;
    }
    return 0;
}


int main()
{

  int _polldelay = 150000;   // usec;
  uint64 code;
  avr_device_t _device;
  int i;

  /* open device */
  _device = avr_open();
  if (_device != NULL ) {
    printf("avr_open o.k.\n");
  } else {
    printf("error open avr_open\n");
    exit (-1);
  }

  /* run echotest */
  for (i=1; i<5; i++) {
    echotest(_device, i);
  }

  /* poll for ir codes */
  for (;;)
  {
    code = getkey_rc5(_device);
    if ( code !=0 ) {
      printf("RC Code: %u \n", code);
    }
    usleep(_polldelay);
  }
}

